(define-module (ordo playbook)
  #:use-module (ice-9 eval-string)
  #:use-module (ice-9 textual-ports)
  #:use-module (oop goops)
  #:use-module (ordo context)
  #:use-module (ordo logger)
  #:use-module (ordo play)
  #:use-module (srfi srfi-26)
  #:use-module (srfi srfi-69)
  #:export (<playbook>
            playbook
            playbook?
            playbook-name
            playbook-vars
            playbook-plays
            load-playbook
            run-playbook)
  #:re-export (play))

(define-class <playbook> ()
  (name #:init-keyword #:name #:getter playbook-name)
  (vars #:init-keyword #:vars #:getter playbook-vars)
  (plays #:init-keyword #:plays #:getter playbook-plays))

(define-method (initialize (object <playbook>) initargs)
  (next-method)
  (slot-set! object 'vars (alist->hash-table (slot-ref object 'vars)))
  object)

(define (playbook . args)
  (apply make <playbook> args))

(define (playbook? p)
  (is-a? p <playbook>))

(define (load-playbook filename)
  (log-msg 'INFO "Loading playbook " filename)
  (eval-string (call-with-input-file filename get-string-all)
               #:file filename))

(define (run-playbook pb inventory)
  (log-msg 'NOTICE "Running playbook: " (playbook-name pb))
  (parameterize ((*inventory* inventory)
                 (*playbook-vars* (playbook-vars pb)))
    (for-each run-play (playbook-plays pb))))
